<template>
    <div class="vh-100 d-flex justify-content-center align-items-center">
        <div class="container">
            <div class="row d-flex justify-content-center">
                <div class="col-12 col-md-8 col-lg-6">
                    <div class="card bg-white shadow-lg">
                        <div class="card-body p-5">
                            <div class="fw-bold my-2 text-uppercase text-center">
                                <img src="/logo.webp" alt="Logo" width="200" height="50" class="img-fluid">
                            </div>
                            <form class="mb-2 mt-md-4" @submit.prevent="login">
                                <h2 class="mb-3 text-uppercase text-center">Login</h2>
                                <p class="text-danger mt-3" v-if="error">{{ error }}</p>
                                <div class="mb-3">
                                    <label for="email" class="form-label ">Email address</label>
                                    <input type="text" class="form-control " id="email"
                                        placeholder="Enter your email address" v-model="loginForm.email"
                                        :class="[v$.email.$error || errors.hasOwnProperty('email') ? 'is-invalid' : '']">
                                    <div class="invalid-feedback" v-if="v$.email.$error || errors.hasOwnProperty('email')">
                                        {{
                                            v$.email.$error ? v$.email.$errors[0].$message : (
                                                errors.hasOwnProperty('email') ? errors.email[0] : '') }}
                                    </div>
                                </div>
                                <div class="mb-3">
                                    <label for="password" class="form-label ">Password</label>
                                    <input type="password" class="form-control" id="password"
                                        placeholder="Enter your password" v-model="loginForm.password"
                                        :class="[v$.password.$error || errors.hasOwnProperty('password') ? 'is-invalid' : '']">
                                    <div class="invalid-feedback" v-if="v$.password.$error">{{
                                        v$.password.$errors[0].$message }}
                                    </div>
                                    <div class="invalid-feedback" v-if="errors.hasOwnProperty('password')">{{
                                        errors.password[0] }}
                                    </div>
                                </div>

                                <div class="d-grid">
                                    <button class="btn btn-outline-dark" type="submit">Login</button>
                                </div>
                            </form>
                            <div>
                                <p class="mb-0  text-center">Don't have an account? <router-link :to="{ name: 'Register' }"
                                        class="text-primary fw-bold">Sign
                                        Up</router-link></p>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
import { reactive, ref } from 'vue'
import { useRouter } from 'vue-router'
import { useStore } from 'vuex'
import { useVuelidate } from '@vuelidate/core'
import { required, email, helpers } from '@vuelidate/validators'

export default {
    setup() {

        const router = useRouter();
        const store = useStore();
        let error = ref('');
        let errors = ref([]);

        let loginForm = reactive({
            email: '',
            password: '',
        });

        // Form validation rules
        const rules = {
            email: {
                required: helpers.withMessage('Email address is required.', required),
                email: helpers.withMessage('Email address must be valid.', email),
            },
            password: { required: helpers.withMessage('Password is required.', required) },

        }
        const v$ = useVuelidate(rules, loginForm);

        const login = async () => {
            const formValidate = await v$.value.$validate();
            if (formValidate) {
                error.value = '';
                errors.value = [];
                await axios.post("/api/login", loginForm).
                    then(res => {
                        if (res.data.success) {
                            store.dispatch('setToken', res.data.data.token);
                            router.push({ name: 'Home' })
                        } else {
                            error.value = res.data.message;
                        }
                    }).catch(e => {
                        if (e.response.status == 422) {
                            errors.value = e.response.data.data;
                        } else {
                            error.value = e.response.data.message;
                        }
                    });
            }
        }

        return {
            loginForm,
            login,
            v$,
            errors,
            error
        }
    }
}
</script>